#include <iostream>
#include <fstream>
#include <vector>
#include <sstream>
#include <bitset>
#include <limits>
#include <unordered_map>

#define main(x) main(int argc, char *argv[]) \
try                                          \
{                                            \
  x ## _unused_, args(argv, argc + argv);    \
  throw args;                                \
} catch (x)

bool allowComments = true;
std::string decToBin(int n) {
    std::string str = "0";

    if (n > 0) {
        str = std::bitset<std::numeric_limits<unsigned int>::digits>(n).to_string();
        str = str.substr(str.find('1')); // remove leading zeros
    }

    if (str.length() < 5) {
        int diff = 5 - str.length();
        for (int i = 0; i < diff; i++) {
            str = "0" + str;
        }
    }
    return str;
}

std::string decToBin(int n, int sz) {
    std::string str = "0";

    if (n > 0) {
        str = std::bitset<std::numeric_limits<unsigned int>::digits>(n).to_string();
        str = str.substr(str.find('1')); // remove leading zeros
    }

    if (str.length() < sz) {
        int diff = sz - str.length();
        for (int i = 0; i < diff; i++) {
            str = "0" + str;
        }
    }
    return str;
}

std::string pad(std::string str, std::string comment) {
    std::string output;
    for (int i = 0; i < 20; i++) {

        if (str.length() > i) {
            output += str.at(i);
        }
        else {
            output += "0";
        }
        if((i+1)%5 == 0) {
            output += " ";
        }
    }
    if (comment != "" && allowComments) {
        output += " ; " + comment;
    }
    return output;
}

std::string fill(std::string str, int len) {
    std::string output = "";
    std::string cstr   = str;
    int strcount = 0;
    while (output.length() < len) {
        if (cstr != "") {
            output = cstr.back() + output;
            cstr.pop_back();
        }
        else {
            output = "0" + output;
        }
    }
    return output;
}

int strToInt(std::string s) {
    int val = 0;
    std::stringstream ss(s);
    ss >> val;
    return val;
}

std::string intToStr(int s) {
    std::string val = "";
    std::stringstream ss;
    ss << s;
    ss >> val;
    return val;
}

std::string removeComments(std::string s) {
    std::string output;
    for (int i = 0; i < s.length(); i++) {
        if(s.at(i) == ';') {
            break;
        }
        output += s.at(i);
    }
    return s;
}

std::string trim(std::string s) {
    std::string result = "";
    for (int i = 0; i < s.size(); i++) {
        if (s.at(i) != ' ') {
            result += s.at(i);
        }
    }
    return result;
}

int getlineNumberOf(std::unordered_map<std::string, int> lmap, std::string key) {
    key = trim(key);
    try {
        std::unordered_map<std::string, int>::iterator result = lmap.find(key);
        if (result == lmap.end()) {
            return -1;
        }
        else {
            return result->second - 1;
        }
    }
    catch(std::exception ex) {

    }
}

int getMemAddressOfVariable(std::unordered_map<std::string, int> varlist, std::string key) {
    key = trim(key);
    try {
        std::unordered_map<std::string, int>::iterator result = varlist.find(key);
        if (result == varlist.end()) {
            return -1;
        }
        else {
            return result->second;
        }
    }
    catch(std::exception ex) {

    }
}

int main(std::vector <std::string> args)
{
    //return 0;
    if (args.size() == 1) {
        args.insert(args.end(), "test.txt");
        args.insert(args.end(), "result.txt");
        //args.insert(args.end(), "-nocomments");
    }
    if (args.size() >= 3) {
        std::string filename = args.at(1);
        std::string outputname = args.at(2);
        std::string optional;
        try {
            optional = args.at(3);
            if (optional == "-nocomments") {
                allowComments = false;
            }
        }
        catch(std::exception ex) {

        }
        std::unordered_map<std::string, int> labelList, varmap;

        std::vector <std::string> content, varlist;
        std::ifstream file(filename);
        std::ofstream output(outputname);
        int spaceCount = 0;

        if (file.is_open() && output.is_open()) {
            std::string line = "";
            int lineCount= 0;
            bool isLabel = false;
            bool declVar = false;
            bool useVar  = false;
            bool errorChecker = false;
            std::vector<std::string> labelStack;
            while (std::getline(file, line)) {
                errorChecker = true;
                line = removeComments(line);
                std::string cmd = line.substr(0, 3);
                if (line.at(line.size() - 1) == ':') {

                    line.pop_back();
                    isLabel = true;
                    if (labelStack.size() != 0) {
                        std::cerr << "Error: Cannot define a label under another label," << std::endl;
                        break;
                    }
                    int found = getlineNumberOf(labelList, line);
                    if (found == -1) {
                        std::pair<std::string, int> label(line, lineCount + 1);
                        labelList.insert(label);
                        labelStack.insert(labelStack.end(), line);
                        continue;
                    }
                    else {
                        std::cerr << "Error: Label " << line << " already found. Label already defined at " << found << " when attempting to define on " << (lineCount + 1) << std::endl;
                        break;
                    }

                }
                else {
                    if (labelStack.size() != 0) {
                        labelStack.pop_back();
                    }
                }

                if (cmd == "dcl") {
                    lineCount += 2;
                }
                else if (cmd == "asg" || cmd == "sns") {
                    lineCount += 2;
                }
                else if (cmd == "add" || cmd == "sub" || cmd == "mul") {
                    lineCount += 4;
                }
                else if (cmd == "cmp") {
                    lineCount += 5;
                }
                else if (!isLabel) {
                    lineCount += 1;
                }
                else {
                    isLabel = false;
                    lineCount += 1;
                }
                errorChecker = false;
            }

            file.close();
            file.open(filename);
            if (!errorChecker) {
                while (std::getline(file, line)) {
                    errorChecker = true;
                    line = removeComments(line);
                    std::string cmd = line.substr(0, 3);
                    if (cmd == "hlt") {
                        output << pad(decToBin(0) + line.substr(3, std::string::npos), "Halt command (" + line + ")") << std::endl;
                    }
                    else if (cmd == "fwd") {
                        output << pad(decToBin(1), "Forward robot (" + line + ")") << std::endl;
                    }
                    else if (cmd == "lft") {
                        output << pad(decToBin(2), "Turn left (" + line + ")") << std::endl;
                    }
                    else if (cmd == "rgt") {
                        output << pad(decToBin(3), "Turn right (" + line + ")") << std::endl;
                    }
                    else if (cmd == "sns") {
                        output << pad(decToBin(4) + fill(decToBin(3), 15), "Use sense command and store it to register 3 (" + line + ")") << std::endl;
                        std::string varn= trim(line.substr(3, std::string::npos));
                        int address = getMemAddressOfVariable(varmap, varn);
                        if (address != -1) {
                            output << pad(decToBin(16) + fill(decToBin(3), 2) + fill(decToBin(address), 13), "Store value of register 3 to " + intToStr(address) + " which is the memory address of variable " + varn + " (" + line + ")") << std::endl;
                        }
                        else {
                            std::cerr << "Error: Variable " << varn << "is not defined. Sense requires a valid variable to store data" << std::endl;
                            break;
                        }

                    }
                    else if (cmd == "jmp") {
                        std::string tmp = decToBin(5);
                        //int lineNum = strToInt(line.substr(3, std::string::npos)) - 1;
                        std::string lineName = line.substr(3, std::string::npos);
                        int lineNum = getlineNumberOf(labelList, lineName);
                        if (lineNum != -1) {
                            std::string tmp2= decToBin( lineNum ) ;
                            output << pad(tmp + fill(tmp2, 15), "Jump to line " + intToStr(lineNum + 1) + " [Label: " + lineName + "] (" + line + ")") << std::endl;
                        }
                        else {
                            std::cerr << "Error: Label named " << line.substr(3, std::string::npos) << " not found." << std::endl;
                            break;
                        }
                    }
                    else if (cmd == "add") {
                        std::string tmp = decToBin(12);
                        std::string subs= line.substr(3, std::string::npos);
                        std::istringstream splitter(subs);
                        std::vector<std::string> lines;
                        std::string tmp2;
                        while (std::getline(splitter, tmp2, ',')) {
                            lines.insert(lines.end(), tmp2);
                        }

                        int address = getMemAddressOfVariable(varmap, lines.at(0));
                        if (address != -1) {
                            output << pad(decToBin(15) + fill(decToBin(0), 2) + fill(decToBin(address), 13) , "Read memory address of " + intToStr(address) + " of variable " + lines.at(0) + " and store to register 0 (" + line + ")") << std::endl;
                        }
                        else {
                            output << pad(decToBin(17) + fill(decToBin(0), 2) + fill(decToBin(strToInt(lines.at(0))), 13), "Store value " + lines.at(0) + " to reg 0 (" + line + ")") << std::endl;
                        }

                        int address2 = getMemAddressOfVariable(varmap, lines.at(1));
                        if (address2 != -1) {
                            output << pad(decToBin(15) + fill(decToBin(1), 2) + fill(decToBin(address2), 13) , "Read memory address of " + intToStr(address2) + " of variable " + lines.at(1) + " and store to register 1 (" + line + ")") << std::endl;
                        }
                        else {
                            output << pad(decToBin(17) + fill(decToBin(1), 2) + fill(decToBin(strToInt(lines.at(1))), 13), "Store value " + lines.at(1) + " to reg 1 (" + line + ")") << std::endl;
                        }

                        int address3 = getMemAddressOfVariable(varmap, lines.at(2));
                        if (address3 != -1) {
                            output << pad(decToBin(12) + fill(decToBin(0), 2) + fill(decToBin(1), 2) + fill(decToBin(2), 2) , "Add values of register 0 and register 1 and store to register 2 (" + line + ")") << std::endl;
                            output << pad(decToBin(16) + fill(decToBin(2), 2) + fill(decToBin(address3), 13), "Store value of register 2 to memory address of " + lines.at(2) + " (" + line + ")") << std::endl;
                        }
                        else {
                            std::cerr << "Error: Variable " << lines.at(2) << " does not exists when trying to do an arithmetic operation" << std::endl;
                            break;
                        }
                    }
                    else if (cmd == "sub") {
                        std::string tmp = decToBin(12);
                        std::string subs= line.substr(3, std::string::npos);
                        std::istringstream splitter(subs);
                        std::vector<std::string> lines;
                        std::string tmp2;
                        while (std::getline(splitter, tmp2, ',')) {
                            lines.insert(lines.end(), tmp2);
                        }

                        int address = getMemAddressOfVariable(varmap, lines.at(0));
                        if (address != -1) {
                            output << pad(decToBin(15) + fill(decToBin(0), 2) + fill(decToBin(address), 13) , "Read memory address of " + intToStr(address) + " of variable " + lines.at(0) + " and store to register 0 (" + line + ")") << std::endl;
                        }
                        else {
                            output << pad(decToBin(17) + fill(decToBin(0), 2) + fill(decToBin(strToInt(lines.at(0))), 13), "Store value " + lines.at(0) + " to register 0 (" + line + ")") << std::endl;
                        }

                        int address2 = getMemAddressOfVariable(varmap, lines.at(1));
                        if (address2 != -1) {
                            output << pad(decToBin(15) + fill(decToBin(1), 2) + fill(decToBin(address2), 13) , "Read memory address of " + intToStr(address2) + " of variable " + lines.at(1) + " and store to register 1 (" + line + ")") << std::endl;
                        }
                        else {
                            output << pad(decToBin(17) + fill(decToBin(1), 2) + fill(decToBin(strToInt(lines.at(1))), 13), "Store value " + lines.at(1) + " to register 1 (" + line + ")") << std::endl;
                        }

                        int address3 = getMemAddressOfVariable(varmap, lines.at(2));
                        if (address3 != -1) {
                            output << pad(decToBin(13) + fill(decToBin(0), 2) + fill(decToBin(1), 2) + fill(decToBin(2), 2) , "Subtract values of register 0 and register 1 and store to register 2 (" + line + ")") << std::endl;
                            output << pad(decToBin(16) + fill(decToBin(2), 2) + fill(decToBin(address3), 13), "Store value of register 2 to memory address of " + lines.at(2) + " (" + line + ")") << std::endl;
                        }
                        else {
                            std::cerr << "Error: Variable " << lines.at(2) << " does not exists when trying to do an arithmetic operation" << std::endl;
                            break;
                        }
                    }
                    else if (cmd == "mul") {
                        std::string tmp = decToBin(12);
                        std::string subs= line.substr(3, std::string::npos);
                        std::istringstream splitter(subs);
                        std::vector<std::string> lines;
                        std::string tmp2;
                        while (std::getline(splitter, tmp2, ',')) {
                            lines.insert(lines.end(), tmp2);
                        }

                        int address = getMemAddressOfVariable(varmap, lines.at(0));
                        if (address != -1) {
                            output << pad(decToBin(15) + fill(decToBin(0), 2) + fill(decToBin(address), 13) , "Read memory address of " + intToStr(address) + " of variable " + lines.at(0) + " and store to register 0 (" + line + ")") << std::endl;
                        }
                        else {
                            output << pad(decToBin(17) + fill(decToBin(0), 2) + fill(decToBin(strToInt(lines.at(0))), 13), "Store value " + lines.at(0) + " to reg 0 (" + line + ")") << std::endl;
                        }

                        int address2 = getMemAddressOfVariable(varmap, lines.at(1));
                        if (address2 != -1) {
                            output << pad(decToBin(15) + fill(decToBin(1), 2) + fill(decToBin(address2), 13) , "Read memory address of " + intToStr(address2) + " of variable " + lines.at(1) + " and store to register 1 (" + line + ")") << std::endl;
                        }
                        else {
                            output << pad(decToBin(17) + fill(decToBin(1), 2) + fill(decToBin(strToInt(lines.at(1))), 13), "Store value " + lines.at(1) + " to reg 1 (" + line + ")") << std::endl;
                        }

                        int address3 = getMemAddressOfVariable(varmap, lines.at(2));
                        if (address3 != -1) {
                            output << pad(decToBin(14) + fill(decToBin(0), 2) + fill(decToBin(1), 2) + fill(decToBin(2), 2) , "Multiply values of register 0 and register 1 and store to register 2 (" + line + ")") << std::endl;
                            output << pad(decToBin(16) + fill(decToBin(2), 2) + fill(decToBin(address3), 13), "Store value of register 2 to memory address of " + lines.at(2) + " (" + line + ")") << std::endl;
                        }
                        else {
                            std::cerr << "Error: Variable " << lines.at(2) << " does not exists when trying to do an arithmetic operation" << std::endl;
                            break;
                        }
                    }
                    else if (cmd == "dcl") {
                        std::string tmp = decToBin(15);
                        std::string subs= line.substr(3, std::string::npos);
                        std::istringstream splitter(subs);
                        std::vector<std::string> lines;
                        std::vector<std::string> lline;
                        bool isVariable = false;
                        int varAddress  = -1;
                        std::string tmp2;
                        int sz[2] = {2, 13};
                        while (std::getline(splitter, tmp2, ',')) {

                            lline.insert(lline.end(), tmp2);
                            if (lines.size() == 0) {
                                lines.insert(lines.end(), trim(tmp2));
                            }
                            else {

                                int found = getMemAddressOfVariable(varmap, tmp2);
                                if (found != -1) {
                                    isVariable = true;
                                    varAddress = found;
                                    tmp2 = decToBin( varAddress, 15 );
                                    lines.insert(lines.end(), tmp2);
                                }
                                else {
                                    tmp2 = decToBin( strToInt(tmp2), 2 );
                                    lines.insert(lines.end(), fill(tmp2, sz[lines.size()]) );
                                }
                            }
                        }

                        std::string varn= lines.at(0);
                        int found = getMemAddressOfVariable(varmap, varn);
                        if (found == -1 && !isVariable) {
                            std::pair<std::string, int> variable(varn, varlist.size());
                            varmap.insert(variable);
                            varlist.insert(varlist.end(), varn);
                            output << pad(decToBin(17) + fill(decToBin(0), 2) + lines.at(1), "Set register 0 to value " + lline.at(1) +"[" + lines.at(1) + "](" + line + ")") << std::endl;
                            output << pad(decToBin(16) + fill(decToBin(0), 2) + fill(decToBin(variable.second), 13), "Write to memory address " + intToStr(variable.second) + " which will the address of variable " + varn + " (" + line + ")") << std::endl;
                        }
                        else if (found == -1 && isVariable) {
                            std::pair<std::string, int> variable(varn, varlist.size());
                            varmap.insert(variable);
                            varlist.insert(varlist.end(), varn);
                            output << pad(decToBin(15) + lines.at(1), "Read memory address of " + intToStr(varAddress) + " which is the address of variable " + lline.at(1) + " [" + lines.at(1) + "](" + line + ")") << std::endl;
                            output << pad(decToBin(16) + fill(decToBin(0), 2) + fill(decToBin(variable.second), 13), "Write to memory address " + intToStr(variable.second) + " which will the address of variable " + varn + " (" + line + ")") << std::endl;
                        }
                        else {
                            std::cerr << "Error: Variable " << varn << " already defined at an earlier statement. Use asg (assign) instead." << std::endl;
                            break;
                        }
                    }
                    else if (cmd == "asg") {
                        std::string tmp = decToBin(15);
                        std::string subs= line.substr(3, std::string::npos);
                        std::istringstream splitter(subs);
                        std::vector<std::string> lines;
                        std::vector<std::string> lline;
                        bool isVariable = false;
                        int varAddress  = -1;
                        std::string tmp2;
                        int sz[2] = {2, 13};
                        while (std::getline(splitter, tmp2, ',')) {
                            lline.insert(lline.end(), tmp2);
                            if (lines.size() == 0) {
                                lines.insert(lines.end(), trim(tmp2));
                            }
                            else {

                                int found = getMemAddressOfVariable(varmap, tmp2);
                                if (found != -1) {
                                    isVariable = true;
                                    varAddress = found;
                                    tmp2 = decToBin( varAddress, 15 );
                                    lines.insert(lines.end(), tmp2);
                                }
                                else {
                                    tmp2 = decToBin( strToInt(tmp2), 2 );
                                    lines.insert(lines.end(), fill(tmp2, sz[lines.size()]) );
                                }

                            }
                        }

                        std::string varn= lines.at(0);
                        int address = getMemAddressOfVariable(varmap, varn);
                        if (address != -1 && !isVariable) {
                            output << pad(decToBin(17) + fill(decToBin(3), 2) + lines.at(1), "Set register 3 value to " + lline.at(1) + " (" + line + ")") << std::endl;
                            output << pad(decToBin(16) + fill(decToBin(3), 2) + fill(decToBin(address), 13), "Write to memory address " + intToStr(address) + " which is the address of variable " + varn + " (" + line + ")") << std::endl;
                        }
                        else if (address != -1 && isVariable) {
                            output << pad(decToBin(15) + lines.at(1), "Read memory address of " + intToStr(varAddress) + " which is the address of variable " + lline.at(1) + " [" + lines.at(1) + "](" + line + ")") << std::endl;
                            output << pad(decToBin(16) + fill(decToBin(0), 2) + fill(decToBin(address), 13), "Write to memory address " + intToStr(address) + " which will the address of variable " + varn + " (" + line + ")") << std::endl;
                        }
                        else {
                            std::cerr << "Error: Variable " << varn << " is not defined yet. Use dcl command instead." << std::endl;
                            break;
                        }
                    }
                    else if (cmd == "cmp") {
                        std::string subs= line.substr(4, std::string::npos);
                        std::istringstream splitter(subs);
                        std::string tmp2;
                        std::string opr;
                        std::vector<std::string> params;
                        while (std::getline(splitter, tmp2, ' ')) {
                            params.insert(params.end(), trim(tmp2));
                        }
                        int address = getMemAddressOfVariable(varmap, params.at(0));

                        if (address != -1) {
                            output << pad(decToBin(15) + fill(decToBin(0), 2) + fill(decToBin(address), 13) , "Read memory address " + intToStr(address) + " which is the address of variable " + params.at(0) + " [" + decToBin(address, 13) + "] and store to register 0 (" + line + ")") << std::endl;
                        }
                        else {
                            output << pad(decToBin(17) + fill(decToBin(0), 2) + fill(decToBin(strToInt(params.at(0))), 13), "Store value " + params.at(0) + " to register 0 (" + line + ")") << std::endl;
                        }

                        opr = params.at(1);

                        int address2 = getMemAddressOfVariable(varmap, params.at(2));
                        if (address2 != -1) {
                            output << pad(decToBin(15) + fill(decToBin(1), 2) + fill(decToBin(address2), 13) , "Read memory address " + intToStr(address2) + " which is the address of variable " + params.at(2) + " [" + decToBin(address2, 13) + "] and store to register 1 (" + line + ")") << std::endl;
                        }
                        else {
                            output << pad(decToBin(17) + fill(decToBin(1), 2) + fill(decToBin(strToInt(params.at(1))), 13), "Store value " + params.at(0) + " to register 1 (" + line + ")") << std::endl;
                        }
                        output << pad(decToBin(13) + fill(decToBin(0), 2) + fill(decToBin(1), 2) + fill(decToBin(2), 2) , "Subtract value of register 0 and register 1 and store it to register 2 (" + line + ")") << std::endl;
                        int lineTrue = -1, lineFalse = -1;
                        if (opr == ">") {
                            try {
                                lineTrue = getlineNumberOf(labelList, params.at(3));
                                if (lineTrue != -1) {
                                    output << pad(decToBin(8) + fill(decToBin(2), 2) + fill(decToBin(lineTrue), 13), "Jump to line " + intToStr(lineTrue + 1) + " if value of register 2 is greater than 0 (" + line + ")") << std::endl;
                                }
                                else {
                                    std::cerr << "Error: Cannot find label " << params.at(3) << "."<< std::endl;
                                    break;
                                }
                            }
                            catch(std::exception ex) {
                                std::cerr << "Error: Missing parameters for cmd command." << std::endl;
                                break;
                            }

                            try {
                                lineFalse = getlineNumberOf(labelList, params.at(4));
                                if (lineFalse != -1) {
                                    output << pad(decToBin(11) + fill(decToBin(2), 2) + fill(decToBin(lineFalse), 13), "Jump to line " + intToStr(lineFalse + 1) + " if value of register 2 is less than or equal 0 (" + line + ")") << std::endl;
                                }
                                else {
                                    std::cerr << "Error: Cannot find label " << params.at(4) << "."<< std::endl;
                                    break;
                                }
                            }
                            catch(std::exception ex) {
                                std::cerr << "Error: Missing parameters for cmd command." << std::endl;
                                break;
                            }
                        }
                        else if (opr == "=") {
                            try {
                                lineTrue = getlineNumberOf(labelList, params.at(3));
                                if (lineTrue != -1) {
                                    output << pad(decToBin(6) + fill(decToBin(2), 2) + fill(decToBin(lineTrue), 13), "Jump to line " + intToStr(lineTrue + 1) + " if value of register 2 is equal to 0 (" + line + ")") << std::endl;
                                }
                                else {
                                    std::cerr << "Error: Cannot find label " << params.at(3) << "."<< std::endl;
                                    break;
                                }
                            }
                            catch(std::exception ex) {
                                std::cerr << "Error: Missing parameters for cmd command." << std::endl;
                                break;
                            }

                            try {
                                lineFalse = getlineNumberOf(labelList, params.at(4));
                                if (lineFalse != -1) {
                                    output << pad(decToBin(7) + fill(decToBin(2), 2) + fill(decToBin(lineFalse), 13), "Jump to line " + intToStr(lineFalse + 1) + " if value of register 2 is not equal to 0 (" + line + ")") << std::endl;
                                }
                                else {
                                    std::cerr << "Error: Cannot find label " << params.at(4) << "."<< std::endl;
                                    break;
                                }
                            }
                            catch(std::exception ex) {
                                std::cerr << "Error: Missing parameters for cmd command." << std::endl;
                                break;
                            }
                        }
                        else if (opr == "<") {
                            try {
                                lineTrue = getlineNumberOf(labelList, params.at(3));
                                if (lineTrue != -1) {
                                    output << pad(decToBin(9) + fill(decToBin(2), 2) + fill(decToBin(lineTrue), 13), "Jump to line " + intToStr(lineTrue + 1) + " if value of register 2 is less than 0 (" + line + ")") << std::endl;
                                }
                                else {
                                    std::cerr << "Error: Cannot find label " << params.at(3) << "."<< std::endl;
                                    break;
                                }
                            }
                            catch(std::exception ex) {
                                std::cerr << "Error: Missing parameters for cmd command." << std::endl;
                                break;
                            }

                            try {
                                lineFalse = getlineNumberOf(labelList, params.at(4));
                                if (lineFalse != -1) {
                                    output << pad(decToBin(10) + fill(decToBin(2), 2) + fill(decToBin(lineFalse), 13), "Jump to line " + intToStr(lineFalse + 1) + " if value of register 2 is greater than or equal to 0 (" + line + ")") << std::endl;
                                }
                                else {
                                    std::cerr << "Error: Cannot find label " << params.at(4) << "."<< std::endl;
                                    break;
                                }
                            }
                            catch(std::exception ex) {
                                std::cerr << "Error: Missing parameters for cmd command." << std::endl;
                                break;
                            }
                        }
                        else if (opr == "<=") {
                            try {
                                lineTrue = getlineNumberOf(labelList, params.at(3));
                                if (lineTrue != -1) {
                                    output << pad(decToBin(11) + fill(decToBin(2), 2) + fill(decToBin(lineTrue), 13), "Jump to line " + intToStr(lineTrue + 1) + " if value of register 2 is less than or equal to 0 (" + line + ")") << std::endl;
                                }
                                else {
                                    std::cerr << "Error: Cannot find label " << params.at(3) << "."<< std::endl;
                                    break;
                                }
                            }
                            catch(std::exception ex) {
                                std::cerr << "Error: Missing parameters for cmd command." << std::endl;
                                break;
                            }

                            try {
                                lineFalse = getlineNumberOf(labelList, params.at(4));
                                if (lineFalse != -1) {
                                    output << pad(decToBin(8) + fill(decToBin(2), 2) + fill(decToBin(lineFalse), 13), "Jump to line " + intToStr(lineFalse + 1) + " if value of register 2 is greater than 0 (" + line + ")") << std::endl;
                                }
                                else {
                                    std::cerr << "Error: Cannot find label " << params.at(4) << "."<< std::endl;
                                    break;
                                }
                            }
                            catch(std::exception ex) {
                                std::cerr << "Error: Missing parameters for cmd command." << std::endl;
                                break;
                            }
                        }
                        else if (opr == ">=") {

                            try {
                                lineTrue = getlineNumberOf(labelList, params.at(3));
                                if (lineTrue != -1) {
                                    output << pad(decToBin(10) + fill(decToBin(2), 2) + fill(decToBin(lineTrue), 13), "Jump to line " + intToStr(lineTrue + 1) + " if value of register 2 is greater than or equal to 0 (" + line + ")") << std::endl;
                                }
                                else {
                                    std::cerr << "Error: Cannot find label " << params.at(3) << "."<< std::endl;
                                    break;
                                }
                            }
                            catch(std::exception ex) {
                                std::cerr << "Error: Missing parameters for cmd command." << std::endl;
                                break;
                            }

                            try {
                                lineFalse = getlineNumberOf(labelList, params.at(4));
                                if (lineFalse != -1) {
                                    output << pad(decToBin(9) + fill(decToBin(2), 2) + fill(decToBin(lineFalse), 13), "Jump to line " + intToStr(lineFalse + 1) + " if value of register 2 is less than 0 (" + line + ")") << std::endl;
                                }
                                else {
                                    std::cerr << "Error: Cannot find label " << params.at(4) << "."<< std::endl;
                                    break;
                                }
                            }
                            catch(std::exception ex) {
                                std::cerr << "Error: Missing parameters for cmd command." << std::endl;
                                break;
                            }
                        }
                    }
                    else if (cmd == "rdm") {
                        std::string tmp = decToBin(15);
                        std::string subs= line.substr(3, std::string::npos);
                        std::istringstream splitter(subs);
                        std::vector<std::string> lines;
                        std::vector<std::string> lline;
                        std::string tmp2;
                        int sz[2] = {2, 13};
                        while (std::getline(splitter, tmp2, ',')) {
                            lline.insert(lline.end(), tmp2);
                            tmp2 = decToBin( strToInt(tmp2), sz[lines.size()] );
                            lines.insert(lines.end(), tmp2);
                        }
                        output << pad(tmp + lines.at(0) + lines.at(1), "Read memory address of " + lline.at(1) + " and store it to register " + lline.at(0) + " (" + line + ")") << std::endl;
                    }
                    else if (cmd == "wtm") {
                        std::string tmp = decToBin(16);
                        std::string subs= line.substr(3, std::string::npos);
                        std::istringstream splitter(subs);
                        std::vector<std::string> lines;
                        std::vector<std::string> lline;
                        std::string tmp2;
                        int sz[2] = {2, 13};
                        while (std::getline(splitter, tmp2, ',')) {
                            lline.insert(lline.end(), tmp2);
                            tmp2 = decToBin( strToInt(tmp2), sz[lines.size()] );
                            lines.insert(lines.end(), tmp2);
                        }
                        output << pad(tmp + lines.at(0) + lines.at(1), "Write the value of register " + lline.at(0) + " and store it to memory address " + lline.at(0) + " (" + line + ")") << std::endl;
                    }
                    else if (cmd == "set") {
                        std::string tmp = decToBin(17);
                        std::string subs= line.substr(3, std::string::npos);
                        std::istringstream splitter(subs);
                        std::vector<std::string> lines;
                        std::vector<std::string> lline;
                        std::string tmp2;
                        int sz[2] = {2, 13};
                        while (std::getline(splitter, tmp2, ',')) {
                            lline.insert(lline.end(), tmp2);
                            tmp2 = decToBin( strToInt(tmp2), sz[lines.size()] );
                            lines.insert(lines.end(), tmp2);
                        }
                        output << pad(tmp + lines.at(0) + lines.at(1), "Set register " + lline.at(0) + " to " + lline.at(1) + " (" + line + ")") << std::endl;
                    }
                    else {

                    }

                    errorChecker = false;
                }
            }
            file.close();
            if (errorChecker == false) {
                std::cout << "Compilation successful" << std::endl;
            }
            else {
                std::cout << "Compiler found issues with the code. Compilation unsuccessful. See stderr for details" << std::endl;
            }
        }
        output.close();
    }
    else {
        std::cerr << "Invalid number of parameters" << std::endl;
    }

    return 0;
}
